;;
;; chicken-sdl2: CHICKEN Scheme bindings to Simple DirectMedia Layer 2
;;
;; Copyright © 2013–2021  John Croisant.
;; All rights reserved.
;;
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions
;; are met:
;;
;; - Redistributions of source code must retain the above copyright
;;   notice, this list of conditions and the following disclaimer.
;;
;; - Redistributions in binary form must reproduce the above copyright
;;   notice, this list of conditions and the following disclaimer in
;;   the documentation and/or other materials provided with the
;;   distribution.
;;
;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;; "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;; LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;; FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
;; COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
;; INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
;; (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
;; SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
;; HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
;; STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
;; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
;; OF THE POSSIBILITY OF SUCH DAMAGE.


(export symbol->scancode
        scancode->symbol)


(define-enum-mappings
  type: SDL_Scancode
  symbol->value: symbol->scancode
  value->symbol: scancode->symbol

  ((required: libSDL-2.0.0+ "SDL_VERSION_ATLEAST(2,0,0)")
   (unknown              SDL_SCANCODE_UNKNOWN)

   (a                    SDL_SCANCODE_A)
   (b                    SDL_SCANCODE_B)
   (c                    SDL_SCANCODE_C)
   (d                    SDL_SCANCODE_D)
   (e                    SDL_SCANCODE_E)
   (f                    SDL_SCANCODE_F)
   (g                    SDL_SCANCODE_G)
   (h                    SDL_SCANCODE_H)
   (i                    SDL_SCANCODE_I)
   (j                    SDL_SCANCODE_J)
   (k                    SDL_SCANCODE_K)
   (l                    SDL_SCANCODE_L)
   (m                    SDL_SCANCODE_M)
   (n                    SDL_SCANCODE_N)
   (o                    SDL_SCANCODE_O)
   (p                    SDL_SCANCODE_P)
   (q                    SDL_SCANCODE_Q)
   (r                    SDL_SCANCODE_R)
   (s                    SDL_SCANCODE_S)
   (t                    SDL_SCANCODE_T)
   (u                    SDL_SCANCODE_U)
   (v                    SDL_SCANCODE_V)
   (w                    SDL_SCANCODE_W)
   (x                    SDL_SCANCODE_X)
   (y                    SDL_SCANCODE_Y)
   (z                    SDL_SCANCODE_Z)

   (n-1                  SDL_SCANCODE_1)
   (n-2                  SDL_SCANCODE_2)
   (n-3                  SDL_SCANCODE_3)
   (n-4                  SDL_SCANCODE_4)
   (n-5                  SDL_SCANCODE_5)
   (n-6                  SDL_SCANCODE_6)
   (n-7                  SDL_SCANCODE_7)
   (n-8                  SDL_SCANCODE_8)
   (n-9                  SDL_SCANCODE_9)
   (n-0                  SDL_SCANCODE_0)

   (return               SDL_SCANCODE_RETURN)
   (escape               SDL_SCANCODE_ESCAPE)
   (backspace            SDL_SCANCODE_BACKSPACE)
   (tab                  SDL_SCANCODE_TAB)
   (space                SDL_SCANCODE_SPACE)

   (minus                SDL_SCANCODE_MINUS)
   (equals               SDL_SCANCODE_EQUALS)
   (left-bracket         SDL_SCANCODE_LEFTBRACKET)
   (right-bracket        SDL_SCANCODE_RIGHTBRACKET)
   (backslash            SDL_SCANCODE_BACKSLASH)
   (non-us-hash          SDL_SCANCODE_NONUSHASH)
   (semicolon            SDL_SCANCODE_SEMICOLON)
   (apostrophe           SDL_SCANCODE_APOSTROPHE)
   (grave                SDL_SCANCODE_GRAVE)
   (comma                SDL_SCANCODE_COMMA)
   (period               SDL_SCANCODE_PERIOD)
   (slash                SDL_SCANCODE_SLASH)

   (caps-lock            SDL_SCANCODE_CAPSLOCK)

   (f1                   SDL_SCANCODE_F1)
   (f2                   SDL_SCANCODE_F2)
   (f3                   SDL_SCANCODE_F3)
   (f4                   SDL_SCANCODE_F4)
   (f5                   SDL_SCANCODE_F5)
   (f6                   SDL_SCANCODE_F6)
   (f7                   SDL_SCANCODE_F7)
   (f8                   SDL_SCANCODE_F8)
   (f9                   SDL_SCANCODE_F9)
   (f10                  SDL_SCANCODE_F10)
   (f11                  SDL_SCANCODE_F11)
   (f12                  SDL_SCANCODE_F12)

   (print-screen         SDL_SCANCODE_PRINTSCREEN)
   (scroll-lock          SDL_SCANCODE_SCROLLLOCK)
   (pause                SDL_SCANCODE_PAUSE)
   (insert               SDL_SCANCODE_INSERT)
   (home                 SDL_SCANCODE_HOME)
   (page-up              SDL_SCANCODE_PAGEUP)
   (delete               SDL_SCANCODE_DELETE)
   (end                  SDL_SCANCODE_END)
   (page-down            SDL_SCANCODE_PAGEDOWN)
   (right                SDL_SCANCODE_RIGHT)
   (left                 SDL_SCANCODE_LEFT)
   (down                 SDL_SCANCODE_DOWN)
   (up                   SDL_SCANCODE_UP)

   (num-lock-clear       SDL_SCANCODE_NUMLOCKCLEAR)
   (kp-divide            SDL_SCANCODE_KP_DIVIDE)
   (kp-multiply          SDL_SCANCODE_KP_MULTIPLY)
   (kp-minus             SDL_SCANCODE_KP_MINUS)
   (kp-plus              SDL_SCANCODE_KP_PLUS)
   (kp-enter             SDL_SCANCODE_KP_ENTER)
   (kp-1                 SDL_SCANCODE_KP_1)
   (kp-2                 SDL_SCANCODE_KP_2)
   (kp-3                 SDL_SCANCODE_KP_3)
   (kp-4                 SDL_SCANCODE_KP_4)
   (kp-5                 SDL_SCANCODE_KP_5)
   (kp-6                 SDL_SCANCODE_KP_6)
   (kp-7                 SDL_SCANCODE_KP_7)
   (kp-8                 SDL_SCANCODE_KP_8)
   (kp-9                 SDL_SCANCODE_KP_9)
   (kp-0                 SDL_SCANCODE_KP_0)
   (kp-period            SDL_SCANCODE_KP_PERIOD)

   (non-us-backslash     SDL_SCANCODE_NONUSBACKSLASH)
   (application          SDL_SCANCODE_APPLICATION)
   (power                SDL_SCANCODE_POWER)
   (kp-equals            SDL_SCANCODE_KP_EQUALS)
   (f13                  SDL_SCANCODE_F13)
   (f14                  SDL_SCANCODE_F14)
   (f15                  SDL_SCANCODE_F15)
   (f16                  SDL_SCANCODE_F16)
   (f17                  SDL_SCANCODE_F17)
   (f18                  SDL_SCANCODE_F18)
   (f19                  SDL_SCANCODE_F19)
   (f20                  SDL_SCANCODE_F20)
   (f21                  SDL_SCANCODE_F21)
   (f22                  SDL_SCANCODE_F22)
   (f23                  SDL_SCANCODE_F23)
   (f24                  SDL_SCANCODE_F24)
   (execute              SDL_SCANCODE_EXECUTE)
   (help                 SDL_SCANCODE_HELP)
   (menu                 SDL_SCANCODE_MENU)
   (select               SDL_SCANCODE_SELECT)
   (stop                 SDL_SCANCODE_STOP)
   (again                SDL_SCANCODE_AGAIN)
   (undo                 SDL_SCANCODE_UNDO)
   (cut                  SDL_SCANCODE_CUT)
   (copy                 SDL_SCANCODE_COPY)
   (paste                SDL_SCANCODE_PASTE)
   (find                 SDL_SCANCODE_FIND)
   (mute                 SDL_SCANCODE_MUTE)
   (volume-up            SDL_SCANCODE_VOLUMEUP)
   (volume-down          SDL_SCANCODE_VOLUMEDOWN)
   (kp-comma             SDL_SCANCODE_KP_COMMA)
   (kp-equals-as400      SDL_SCANCODE_KP_EQUALSAS400)

   (international1       SDL_SCANCODE_INTERNATIONAL1)
   (international2       SDL_SCANCODE_INTERNATIONAL2)
   (international3       SDL_SCANCODE_INTERNATIONAL3)
   (international4       SDL_SCANCODE_INTERNATIONAL4)
   (international5       SDL_SCANCODE_INTERNATIONAL5)
   (international6       SDL_SCANCODE_INTERNATIONAL6)
   (international7       SDL_SCANCODE_INTERNATIONAL7)
   (international8       SDL_SCANCODE_INTERNATIONAL8)
   (international9       SDL_SCANCODE_INTERNATIONAL9)
   (lang1                SDL_SCANCODE_LANG1)
   (lang2                SDL_SCANCODE_LANG2)
   (lang3                SDL_SCANCODE_LANG3)
   (lang4                SDL_SCANCODE_LANG4)
   (lang5                SDL_SCANCODE_LANG5)
   (lang6                SDL_SCANCODE_LANG6)
   (lang7                SDL_SCANCODE_LANG7)
   (lang8                SDL_SCANCODE_LANG8)
   (lang9                SDL_SCANCODE_LANG9)

   (alt-erase            SDL_SCANCODE_ALTERASE)
   (sys-req              SDL_SCANCODE_SYSREQ)
   (cancel               SDL_SCANCODE_CANCEL)
   (clear                SDL_SCANCODE_CLEAR)
   (prior                SDL_SCANCODE_PRIOR)
   (return2              SDL_SCANCODE_RETURN2)
   (separator            SDL_SCANCODE_SEPARATOR)
   (out                  SDL_SCANCODE_OUT)
   (oper                 SDL_SCANCODE_OPER)
   (clear-again          SDL_SCANCODE_CLEARAGAIN)
   (crsel                SDL_SCANCODE_CRSEL)
   (exsel                SDL_SCANCODE_EXSEL)

   (kp-00                SDL_SCANCODE_KP_00)
   (kp-000               SDL_SCANCODE_KP_000)
   (thousands-separator  SDL_SCANCODE_THOUSANDSSEPARATOR)
   (decimal-separator    SDL_SCANCODE_DECIMALSEPARATOR)
   (currency-unit        SDL_SCANCODE_CURRENCYUNIT)
   (currency-subunit     SDL_SCANCODE_CURRENCYSUBUNIT)
   (kp-left-paren        SDL_SCANCODE_KP_LEFTPAREN)
   (kp-right-paren       SDL_SCANCODE_KP_RIGHTPAREN)
   (kp-left-brace        SDL_SCANCODE_KP_LEFTBRACE)
   (kp-right-brace       SDL_SCANCODE_KP_RIGHTBRACE)
   (kp-tab               SDL_SCANCODE_KP_TAB)
   (kp-backspace         SDL_SCANCODE_KP_BACKSPACE)
   (kp-a                 SDL_SCANCODE_KP_A)
   (kp-b                 SDL_SCANCODE_KP_B)
   (kp-c                 SDL_SCANCODE_KP_C)
   (kp-d                 SDL_SCANCODE_KP_D)
   (kp-e                 SDL_SCANCODE_KP_E)
   (kp-f                 SDL_SCANCODE_KP_F)
   (kp-xor               SDL_SCANCODE_KP_XOR)
   (kp-power             SDL_SCANCODE_KP_POWER)
   (kp-percent           SDL_SCANCODE_KP_PERCENT)
   (kp-less              SDL_SCANCODE_KP_LESS)
   (kp-greater           SDL_SCANCODE_KP_GREATER)
   (kp-ampersand         SDL_SCANCODE_KP_AMPERSAND)
   (kp-dbl-ampersand     SDL_SCANCODE_KP_DBLAMPERSAND)
   (kp-vertical-bar      SDL_SCANCODE_KP_VERTICALBAR)
   (kp-dbl-vertical-bar  SDL_SCANCODE_KP_DBLVERTICALBAR)
   (kp-colon             SDL_SCANCODE_KP_COLON)
   (kp-hash              SDL_SCANCODE_KP_HASH)
   (kp-space             SDL_SCANCODE_KP_SPACE)
   (kp-at                SDL_SCANCODE_KP_AT)
   (kp-exclam            SDL_SCANCODE_KP_EXCLAM)
   (kp-mem-store         SDL_SCANCODE_KP_MEMSTORE)
   (kp-mem-recall        SDL_SCANCODE_KP_MEMRECALL)
   (kp-mem-clear         SDL_SCANCODE_KP_MEMCLEAR)
   (kp-mem-add           SDL_SCANCODE_KP_MEMADD)
   (kp-mem-subtract      SDL_SCANCODE_KP_MEMSUBTRACT)
   (kp-mem-multiply      SDL_SCANCODE_KP_MEMMULTIPLY)
   (kp-mem-divide        SDL_SCANCODE_KP_MEMDIVIDE)
   (kp-plus-minus        SDL_SCANCODE_KP_PLUSMINUS)
   (kp-clear             SDL_SCANCODE_KP_CLEAR)
   (kp-clear-entry       SDL_SCANCODE_KP_CLEARENTRY)
   (kp-binary            SDL_SCANCODE_KP_BINARY)
   (kp-octal             SDL_SCANCODE_KP_OCTAL)
   (kp-decimal           SDL_SCANCODE_KP_DECIMAL)
   (kp-hexadecimal       SDL_SCANCODE_KP_HEXADECIMAL)

   (lctrl                SDL_SCANCODE_LCTRL)
   (lshift               SDL_SCANCODE_LSHIFT)
   (lalt                 SDL_SCANCODE_LALT)
   (lgui                 SDL_SCANCODE_LGUI)
   (rctrl                SDL_SCANCODE_RCTRL)
   (rshift               SDL_SCANCODE_RSHIFT)
   (ralt                 SDL_SCANCODE_RALT)
   (rgui                 SDL_SCANCODE_RGUI)

   (mode                 SDL_SCANCODE_MODE)

   (audio-next           SDL_SCANCODE_AUDIONEXT)
   (audio-prev           SDL_SCANCODE_AUDIOPREV)
   (audio-stop           SDL_SCANCODE_AUDIOSTOP)
   (audio-play           SDL_SCANCODE_AUDIOPLAY)
   (audio-mute           SDL_SCANCODE_AUDIOMUTE)
   (media-select         SDL_SCANCODE_MEDIASELECT)
   (www                  SDL_SCANCODE_WWW)
   (mail                 SDL_SCANCODE_MAIL)
   (calculator           SDL_SCANCODE_CALCULATOR)
   (computer             SDL_SCANCODE_COMPUTER)
   (ac-search            SDL_SCANCODE_AC_SEARCH)
   (ac-home              SDL_SCANCODE_AC_HOME)
   (ac-back              SDL_SCANCODE_AC_BACK)
   (ac-forward           SDL_SCANCODE_AC_FORWARD)
   (ac-stop              SDL_SCANCODE_AC_STOP)
   (ac-refresh           SDL_SCANCODE_AC_REFRESH)
   (ac-bookmarks         SDL_SCANCODE_AC_BOOKMARKS)

   (brightness-down      SDL_SCANCODE_BRIGHTNESSDOWN)
   (brightness-up        SDL_SCANCODE_BRIGHTNESSUP)
   (display-switch       SDL_SCANCODE_DISPLAYSWITCH)
   (kbd-illum-toggle     SDL_SCANCODE_KBDILLUMTOGGLE)
   (kbd-illum-down       SDL_SCANCODE_KBDILLUMDOWN)
   (kbd-illum-up         SDL_SCANCODE_KBDILLUMUP)
   (eject                SDL_SCANCODE_EJECT)
   (sleep                SDL_SCANCODE_SLEEP)

   (app1                 SDL_SCANCODE_APP1)
   (app2                 SDL_SCANCODE_APP2))

  ((required: libSDL-2.0.6+ "SDL_VERSION_ATLEAST(2,0,6)")
   (audio-rewind         SDL_SCANCODE_AUDIOREWIND)
   (audio-fast-forward   SDL_SCANCODE_AUDIOFASTFORWARD)))
